Index: /LMDZ4/trunk/libf/dyn3dpar/caldyn0.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/caldyn0.F	(revision 1000)
+++ /LMDZ4/trunk/libf/dyn3dpar/caldyn0.F	(revision 1000)
@@ -0,0 +1,89 @@
+!
+! $Header$
+!
+      SUBROUTINE caldyn0
+     $ (itau,ucov,vcov,teta,ps,masse,pk,phis ,
+     $  phi,w,pbaru,pbarv,time )
+
+      IMPLICIT NONE
+
+c=======================================================================
+c
+c  Auteur :  P. Le Van
+c
+c   Objet:
+c   ------
+c
+c   Calcul des tendances dynamiques.
+c
+c Modif 04/93 F.Forget
+c=======================================================================
+
+c-----------------------------------------------------------------------
+c   0. Declarations:
+c   ----------------
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "comconst.h"
+#include "comvert.h"
+#include "comgeom.h"
+
+c   Arguments:
+c   ----------
+
+      INTEGER itau
+      REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm),teta(ip1jmp1,llm)
+      REAL ps(ip1jmp1),phis(ip1jmp1)
+      REAL pk(iip1,jjp1,llm)
+      REAL vcont(ip1jm,llm),ucont(ip1jmp1,llm)
+      REAL phi(ip1jmp1,llm),masse(ip1jmp1,llm)
+      REAL pbaru(ip1jmp1,llm),pbarv(ip1jm,llm)
+      REAL time
+
+c   Local:
+c   ------
+
+      REAL ang(ip1jmp1,llm),p(ip1jmp1,llmp1)
+      REAL massebx(ip1jmp1,llm),masseby(ip1jm,llm),psexbarxy(ip1jm)
+      REAL vorpot(ip1jm,llm)
+      REAL w(ip1jmp1,llm),ecin(ip1jmp1,llm),convm(ip1jmp1,llm)
+      REAL bern(ip1jmp1,llm)
+      REAL massebxy(ip1jm,llm), dp(ip1jmp1)
+    
+
+      INTEGER   ij,l
+
+c-----------------------------------------------------------------------
+c   Calcul des tendances dynamiques:
+c   --------------------------------
+
+      CALL covcont  ( llm    , ucov    , vcov , ucont, vcont        )
+      CALL pression ( ip1jmp1, ap      , bp   ,  ps  , p            )
+      CALL psextbar (   ps   , psexbarxy                            )
+      CALL massdair (    p   , masse                                )
+      CALL massbar  (   masse, massebx , masseby                    )
+      CALL massbarxy(   masse, massebxy                             )
+      CALL flumass  ( massebx, masseby , vcont, ucont ,pbaru, pbarv )
+      CALL convmas  (   pbaru, pbarv   , convm                      )
+
+      DO ij =1, ip1jmp1
+         dp( ij ) = convm( ij,1 ) / airesurg( ij )
+      ENDDO
+
+      CALL vitvert ( convm  , w                                  )
+      CALL tourpot ( vcov   , ucov  , massebxy  , vorpot         )
+      CALL enercin ( vcov   , ucov  , vcont     , ucont  , ecin  )
+      CALL bernoui ( ip1jmp1, llm   , phi       , ecin   , bern  )
+
+      DO l=1,llm
+         DO ij=1,ip1jmp1
+            ang(ij,l) = ucov(ij,l) + constang(ij)
+         ENDDO
+      ENDDO
+
+        CALL sortvarc0
+     $ ( itau,ucov,teta,ps,masse,pk,phis,vorpot,phi,bern,dp,time,vcov )
+
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/calfis_p.F	(revision 1000)
@@ -34,5 +34,5 @@
       USE dimphy
       USE mod_phys_lmdz_para, mpi_root_xx=>mpi_root 
-      USE parallel, ONLY : omp_chunk
+      USE parallel, ONLY : omp_chunk, using_mpi
       USE mod_interface_dyn_phys
       USE Write_Field
@@ -107,6 +107,7 @@
 #include "comgeom2.h"
 #include "control.h"
+#ifdef CPP_MPI
       include 'mpif.h'
-
+#endif
 c    Arguments :
 c    -----------
@@ -212,5 +213,9 @@
       REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
       INTEGER :: ierr
+#ifdef CPP_MPI
       INTEGER,dimension(MPI_STATUS_SIZE,4) :: Status
+#else
+      INTEGER,dimension(1,4) :: Status
+#endif
       INTEGER, dimension(4) :: Req
       REAL,ALLOCATABLE,SAVE:: zdufi2(:,:),zdvfi2(:,:)
@@ -792,5 +797,7 @@
       call stop_timer(timer_physic)
 c$OMP END MASTER
-      
+
+      IF (using_mpi) THEN
+            
       if (MPI_rank>0) then
 
@@ -803,4 +810,5 @@
 
 c$OMP BARRIER
+#ifdef CPP_MPI 
 c$OMP MASTER
 !$OMP CRITICAL (MPI)
@@ -811,4 +819,5 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
+#endif
 c$OMP BARRIER
      
@@ -817,4 +826,5 @@
       if (MPI_rank<MPI_Size-1) then
 c$OMP BARRIER
+#ifdef CPP_MPI 
 c$OMP MASTER      
 !$OMP CRITICAL (MPI)
@@ -825,8 +835,11 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
-c$OMP BARRIER     
+#endif
       endif
 
 c$OMP BARRIER
+
+
+#ifdef CPP_MPI 
 c$OMP MASTER    
 !$OMP CRITICAL (MPI)
@@ -840,6 +853,11 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
+#endif
+
 c$OMP BARRIER     
 
+      ENDIF ! using_mpi
+      
+      
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
       DO l=1,llm
Index: /LMDZ4/trunk/libf/dyn3dpar/conf_gcm.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/conf_gcm.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/conf_gcm.F	(revision 1000)
@@ -712,4 +712,12 @@
       omp_chunk=1
       CALL getin('omp_chunk',omp_chunk)
+
+!Config key = ok_strato
+!Config  Desc = activation de la version strato
+!Config  Def  = .FALSE.
+!Config  Help = active la version stratosphérique de LMDZ de F. Lott
+
+      ok_strato=.FALSE.
+      CALL getin('ok_strato',ok_strato)
 
       write(lunout,*)' #########################################'
@@ -748,4 +756,5 @@
       write(lunout,*)' use_mpi_alloc = ', use_mpi_alloc
       write(lunout,*)' omp_chunk = ', omp_chunk
+      write(lunout,*)' ok_strato = ', ok_strato
 c
       RETURN
Index: /LMDZ4/trunk/libf/dyn3dpar/convflu.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/convflu.F	(revision 1000)
+++ /LMDZ4/trunk/libf/dyn3dpar/convflu.F	(revision 1000)
@@ -0,0 +1,62 @@
+!
+! $Header$
+!
+      SUBROUTINE convflu( xflu,yflu,nbniv,convfl )
+c
+c  P. Le Van
+c
+c
+c    *******************************************************************
+c  ... calcule la (convergence horiz. * aire locale)du flux ayant pour
+c      composantes xflu et yflu ,variables extensives .  ......
+c    *******************************************************************
+c      xflu , yflu et nbniv sont des arguments d'entree pour le s-pg ..
+c      convfl                est  un argument de sortie pour le s-pg .
+c
+c     njxflu  est le nombre de lignes de latitude de xflu, 
+c     ( = jjm ou jjp1 )
+c     nbniv   est le nombre de niveaux vert. de  xflu et de yflu .
+c
+      IMPLICIT NONE
+c
+#include "dimensions.h"
+#include "paramet.h"
+      REAL       xflu,yflu,convfl,convpn,convps
+      INTEGER    l,ij,nbniv
+      DIMENSION  xflu( ip1jmp1,nbniv ),yflu( ip1jm,nbniv ) ,
+     *         convfl( ip1jmp1,nbniv )
+c
+      REAL       SSUM
+c
+c
+#include "comgeom.h"
+c
+      DO 5 l = 1,nbniv
+c
+      DO 2  ij = iip2, ip1jm - 1
+      convfl( ij + 1,l ) =  xflu(   ij,l ) - xflu( ij +  1,l )   +
+     *                      yflu(ij +1,l ) - yflu( ij -iim,l )
+   2  CONTINUE
+c
+c
+
+c     ....  correction pour  convfl( 1,j,l)  ......
+c     ....   convfl(1,j,l)= convfl(iip1,j,l) ...
+c
+CDIR$ IVDEP
+      DO 3 ij = iip2,ip1jm,iip1
+      convfl( ij,l ) = convfl( ij + iim,l )
+   3  CONTINUE
+c
+c     ......  calcul aux poles  .......
+c
+      convpn =   SSUM( iim, yflu(     1    ,l ),  1 )
+      convps = - SSUM( iim, yflu( ip1jm-iim,l ),  1 )
+      DO 4 ij = 1,iip1
+      convfl(     ij   ,l ) = convpn * aire(   ij     ) / apoln
+      convfl( ij+ ip1jm,l ) = convps * aire( ij+ ip1jm) / apols
+   4  CONTINUE
+c
+   5  CONTINUE
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/dyn3dpar/convmas.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/convmas.F	(revision 1000)
+++ /LMDZ4/trunk/libf/dyn3dpar/convmas.F	(revision 1000)
@@ -0,0 +1,63 @@
+!
+! $Header$
+!
+      SUBROUTINE convmas (pbaru, pbarv, convm )
+c
+      IMPLICIT NONE
+
+c=======================================================================
+c
+c   Auteurs:  P. Le Van , F. Hourdin  .
+c   -------
+c
+c   Objet:
+c   ------
+c
+c   ********************************************************************
+c   .... calcul de la convergence du flux de masse aux niveaux p ...
+c   ********************************************************************
+c
+c
+c     pbaru  et  pbarv  sont des arguments d'entree pour le s-pg  ....
+c      .....  convm      est  un argument de sortie pour le s-pg  ....
+c
+c    le calcul se fait de haut en bas, 
+c    la convergence de masse au niveau p(llm+1) est egale a 0. et
+c    n'est pas stockee dans le tableau convm .
+c
+c
+c=======================================================================
+c
+c   Declarations:
+c   -------------
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "comvert.h"
+#include "logic.h"
+
+      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm ),convm(  ip1jmp1,llm )
+      INTEGER   l,ij
+
+
+c-----------------------------------------------------------------------
+c    ....  calcul de - (d(pbaru)/dx + d(pbarv)/dy ) ......
+
+      CALL  convflu( pbaru, pbarv, llm, convm )
+
+c-----------------------------------------------------------------------
+c   filtrage:
+c   ---------
+
+       CALL filtreg( convm, jjp1, llm, 2, 2, .true., 1 )
+
+c    integration de la convergence de masse de haut  en bas ......
+
+      DO      l      = llmm1, 1, -1
+        DO    ij     = 1, ip1jmp1
+         convm(ij,l) = convm(ij,l) + convm(ij,l+1)
+        ENDDO
+      ENDDO
+c
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/dyn3dpar/covnat_p.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/covnat_p.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/covnat_p.F	(revision 1000)
@@ -66,5 +66,5 @@
      
       DO l = 1,klevel
-         DO ij = 1,ip1jm
+         DO ij = ijb,ije
             vnat( ij,l ) = vcov( ij,l ) / cv(ij)
          ENDDO
Index: /LMDZ4/trunk/libf/dyn3dpar/create_etat0_limit.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/create_etat0_limit.F	(revision 1000)
+++ /LMDZ4/trunk/libf/dyn3dpar/create_etat0_limit.F	(revision 1000)
@@ -0,0 +1,87 @@
+!
+! $Header$
+!
+       PROGRAM create_etat0_limit
+       USE dimphy
+       USE comgeomphy
+       USE mod_phys_lmdz_para
+       USE mod_const_mpi
+       USE phys_state_var_mod      
+       IMPLICIT NONE
+c
+c
+c     Programme d'appel a etat0, creation des etats initiaux et limit_netcdf
+c   
+c
+c     interbar = .T . si appel a  interpol. barycentrique inter_barxy
+c
+c     extrap   = .T . si on fait une extrapolation de donnees , comme pour
+c       les  SST  lorsque  le fichier ne contient pas uniquement  des points 
+c     oceaniques .
+c
+c     oldice   = .T. si l'on veut garder les anciennes glaces , obtenues
+c     par  grille_m  ( grid_atob ) .
+c
+c     on cree le masque dans etat0 que l'on passe ensuite dans limit pour 
+c     garder les coherences
+
+      LOGICAL interbar, extrap , oldice
+      PARAMETER ( interbar = .true. , extrap = .FALSE. , oldice=.false.)
+#include "dimensions.h"
+#include "paramet.h"
+#include "indicesol.h"
+#include "advtrac.h"
+#include  "control.h"
+#include "clesphys.h"
+      REAL :: masque(iip1,jjp1)
+!      REAL :: pctsrf(iim*(jjm-1)+2, nbsrf)
+
+c initialisation traceurs
+      hadv_flg(:) = 0.
+      vadv_flg(:) = 0.
+      conv_flg(:) = 0.
+      pbl_flg(:)  = 0. 
+      tracnam(:)  = '        ' 
+      nprath = 1
+      nbtrac = 0
+      mmt_adj(:,:,:,:) = 1
+
+      IF (config_inca /= 'none') THEN
+#ifdef INCA
+         call init_const_lmdz(nbtrac,anneeref,dayref,iphysiq,day_step,nday)
+#endif
+         print *, 'nbtrac =' , nbtrac 
+      END IF
+
+      CALL init_mpi
+
+
+      CALL Init_Phys_lmdz(iim,jjp1,llm,nqmx-2,1,(/(jjm-1)*iim+2/))
+      PRINT *,'---> klon=',klon
+
+      IF (mpi_size>1 .OR. omp_size>1) THEN
+        CALL abort_gcm('create_etat0_limit','In parallel mode, 
+     &                 create_etat0_limit must be called only 
+     &                 for 1 process and 1 task')
+      ENDIF
+      CALL phys_state_var_init
+      call InitComgeomphy
+      
+
+      WRITE(6,*) '  *********************  '
+      WRITE(6,*) ' interbar = ',interbar
+      CALL etat0_netcdf ( interbar, masque )
+c
+      WRITE(6,1)
+      WRITE(6,*) '  *********************  '
+      WRITE(6,*) '  ***  Limit_netcdf ***  '
+      WRITE(6,*) '  *********************  '
+      WRITE(6,1)
+      
+c     
+      CALL  limit_netcdf ( interbar, extrap , oldice, masque)
+
+1     FORMAT(//)
+
+      STOP
+      END
Index: /LMDZ4/trunk/libf/dyn3dpar/disvert.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/disvert.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/disvert.F	(revision 1000)
@@ -11,4 +11,5 @@
 #include "paramet.h"
 #include "iniprint.h"
+#include "logic.h"
 c
 c=======================================================================
@@ -99,5 +100,12 @@
       DO l = 1, llm
          x = 2.*asin(1.) * (FLOAT(l)-0.5) / float(llm+1)
-         dsig(l) = 1.0 + 7.0 * SIN(x)**2
+
+         IF (ok_strato) THEN
+           dsig(l) =(1.0 + 7.0 * SIN(x)**2)
+     &            *(0.5*(1.-tanh(1.*(x-asin(1.))/asin(1.))))**2        
+         ELSE
+           dsig(l) = 1.0 + 7.0 * SIN(x)**2
+         ENDIF
+
          snorm = snorm + dsig(l)
       ENDDO
Index: /LMDZ4/trunk/libf/dyn3dpar/disvert0.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3dpar/disvert0.F	(revision 999)
+++ /LMDZ4/trunk/libf/dyn3dpar/disvert0.F	(revision 1000)
@@ -13,4 +13,5 @@
 #include "paramet.h"
 #include "iniprint.h"
+#include "logic.h"
 c
 c=======================================================================
@@ -104,5 +105,12 @@
       DO l = 1, llm
          x = 2.*asin(1.) * (FLOAT(l)-0.5) / float(llm+1)
-         dsig(l) = 1.0 + 7.0 * SIN(x)**2
+
+         IF (ok_strato) THEN
+           dsig(l) =(1.0 + 7.0 * SIN(x)**2)
+     &            *(0.5*(1.-tanh(1.*(x-asin(1.))/asin(1.))))**2        
+         ELSE
+           dsig(l) = 1.0 + 7.0 * SIN(x)**2
+         ENDIF
+
          snorm = snorm + dsig(l)
       ENDDO
